<template>
    <base-layout>
    <div>
        <form class="form-control">
            <div class="col-md-6">
                <div class="form-group">
                    <label for="password">Testing Security</label>
                    <input type="text" v-model="info.name" class="form-control required email" id="email" name="email"
                        maxlength="128">
                </div>
            </div>
            &nbsp;
            <div>
                <button type="submit" style="color: black" @click.prevent="generate" class="btn btn-success btn-lg mb-1">Submit</button>
                &nbsp;
                <button type="reset" style="color: black" class="btn btn-danger btn-lg mb-1">Cancel</button>
            </div>
        </form>
    </div>
    </base-layout>
</template>

<script>
// import handshake from '../config/handshake.js'
import { pki, util, random, cipher } from "node-forge";
import { POST_KEY, POST_TASK } from "../api/api.js"
export default {
    data(){
        return{
            info:{
                name:""
            },
            encryptedInfo:{
                name:"",
                id:0
            },
            encryptedKey:"",
            handshakeIdd:"",
            keypair:"",
            keyRequest:{
                publicKey:"",
            },
            sharedKey:"",
            Response:"",
            decrypted:""


        }
    },
    methods:{
        generate: async function(){
            await pki.rsa.generateKeyPair({bits: 2048, workers: 2}, (err, k) =>{
                this.keypair = k
            });
            this.keyRequest.publicKey = pki.publicKeyToPem(this.keypair.publicKey);
            console.log(this.keyRequest.publicKey);
            ///sending the public key to server and save the encyrpted shared key
            POST_KEY(this.keyRequest)
            .then((res) => {
                console.log(res);
                this.response = res;
                this.encryptedKey = this.response.encryptedKey;
                this.handshakeIdd = this.response.handshakeId;
                this.sharedKey = util.decode64(this.encryptedKey);
                this.decrypted = this.keypair.privateKey.decrypt(this.sharedKey);
                //console.log(this.decrypted);
                let iv = random.getBytesSync(16);
                const encryption = cipher.createCipher("AES-CBC", this.decrypted);
                encryption.start({ iv });
                encryption.update(util.createBuffer(this.info.name, "utf8"));
                encryption.finish();
                this.encryptedInfo.name = util.encode64(iv + encryption.output.data);
                this.encryptedInfo.id = this.handshakeIdd;

                POST_TASK(this.encryptedInfo).then((res) => {
                    console.log(res);
                }).catch(e => {
                    console.log(e);
                });
                console.log(this.info.name);
                console.log(this.encryptedInfo.name);
                console.log(this.encryptedInfo.id);

                }).catch(e => {
                console.log(e);
                }); 
                

        },
        addTask: function(){
            let iv = random.getBytesSync(16);
            const encryption = cipher.createCipher("AES-CBC", this.decrypted);
            encryption.start({ iv });
            encryption.update(util.createBuffer(this.info.name, "utf8"));
            encryption.finish();
            this.encryptedInfo.name = util.encode64(iv + encryption.output.data);
            console.log(this.encryptedInfo.name);
        }

    },
    mounted(){
        //this.generate()
    }
}
</script>